{This is a graphical component, drawing a dart board on the screen,
 and calculating the points, according to the mouse position.}

{The component is made by
 Martin Djerns (e-mail: martin@djernaes.dk)}

{The is no support on the component, but you are free to use/modify it
 for your own use.}

{FYI : If you want to change the default component-tab, where TDart
 are been shown, the open DartReg.PAS, and change 'Martin Djerns'
 to what ever you like.}

{If you have any changes, please let me get a copy.}
{If you have ides to changes, you don't want to make your self, let
 me know, I might make them for you - BUT I don't prommis any thing.}


{WARNING : The code is not optimised in any way.}



unit Dart;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls;

type
  TPolarPoint = record
    R : Integer;
    V : Real;
  end;

Type
  TOnPointsChanged = Procedure(Sender : TObject; Points : Integer) of Object;

  TDart = class(TGraphicControl)
  private
    { Private declarations }
    FBackColor : TColor;
    FFirstColor : TColor;
    FSecondColor : TColor;
    FFrameColor : TColor;
    FFrameWidth : Integer;
    FDoubleBullFactor : Integer;
    FBullFactor : Integer;
    FTribleMinFactor : Integer;
    FTribleMaxFactor : Integer;
    FDoubleMinFactor : Integer;
    FDoubleBullRadius : LongInt;
    FBullRadius : LongInt;
    FTribleMinRadius : LongInt;
    FTribleMaxRadius : LongInt;
    FDoubleMinRadius : LongInt;
    FDoubleMaxRadius : LongInt;
    FShowNumbers : Boolean;
    FPoints : Integer;
    FCenter : TPoint;
    FMemWidth : Integer;
    FMemHeight : Integer;
    FDrawPoints : Array[1..2,1..20] of TPoint;
    FOnPointsChanged : TOnPointsChanged;
    Procedure SetBackColor(Color : TColor);
    Procedure SetFirstColor(Color : TColor);
    Procedure SetSecondColor(Color : TColor);
    Procedure SetFrameColor(Color : TColor);
    Procedure SetFrameWidth(W : Integer);
    Function XYToPolar(Point : TPoint) : TPolarPoint;
    Function PolarToXY(PolarPoint : TPolarPoint) : TPoint;
    Procedure SetShowNumbers(Show : Boolean);
    Procedure SetPoints(Points : Integer);
  protected
    { Protected declarations }
    Procedure Paint; Override;
    Procedure Calculate;
    Procedure CalculateRadier;
    Procedure CalculateDrawPoints;
    Procedure MouseMove(Shift: TShiftState; X, Y : Integer); Override;
    Procedure PointsChanged(Points : Integer); Dynamic;
  public
    { Public declarations }
    Constructor Create(AOwner : TComponent); Override;
    property Canvas;
  published
    { Published declarations }
    property Align;
    Property BackgroundColor : TColor
      Read FBackColor
      Write SetBackColor
      Default clBlack;
    Property FirstColor : TColor
      Read FFirstColor
      Write SetFirstColor
      Default clGreen;
    Property SecondColor : TColor
      Read FSecondColor
      Write SetSecondColor
      Default clRed;
    Property FrameColor : TColor
      Read FFrameColor
      Write SetFrameColor
      Default clSilver;
    Property FrameWidth : Integer
      Read FFrameWidth
      Write SetFrameWidth
      Default 1;
    Property ShowNumbers : Boolean
      Read FShowNumbers
      Write SetShowNumbers
      Default False;
    Property Points : Integer
      Read FPoints;
    Property OnPointsChanged : TOnPointsChanged
      Read FOnPointsChanged
      Write FOnPointsChanged;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;

implementation

Constructor TDart.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FFrameWidth := 1;
  FBackColor := clBlack;
  FFrameColor := clSilver;
  FFirstColor := clGreen;
  FSecondColor := clRed;
  Canvas.Pen.Style := psSolid;
  Canvas.Pen.Color := FBackColor;
  Canvas.Pen.Width := FFrameWidth;
  Canvas.Brush.Style := bsSolid;
  Canvas.Brush.Color := FBackColor;
  Width := 65;
  Height := Width;
  FMemWidth := 0;
  FMemHeight := 0;
  FDoubleBullFactor := Round(10/172*1000);  {These are suposed to be in}
  FBullFactor := Round(23/172*1000);        {1/1000 parts of the full radius}
  FTribleMinFactor := Round(96/172*1000);
  FTribleMaxFactor := Round(108/172*1000);
  FDoubleMinFactor := Round(160/172*1000);
end;

Function TDart.XYToPolar(Point : TPoint):TPolarPoint;
Var
  PolarPoint : TPolarPoint;
  X,Y : LongInt;
Begin
  If Point.X = 0 Then
  Begin
    PolarPoint.V := 90;
    PolarPoint.R := 0;
  end
  else
  Begin
    PolarPoint.V := ArcTan(Point.Y/Point.X);
    If Point.X < 0 Then
      PolarPoint.V := pi+PolarPoint.V
    else
      If (Point.X > 0) and (Point.Y < 0) Then
        PolarPoint.V := 2*pi+PolarPoint.V;

  end;
  PolarPoint.V := PolarPoint.V/(2*pi)*360;
  X := Point.X;
  Y := Point.Y;
  PolarPoint.R := Round(Sqrt(LongInt(X*X+Y*Y)));
  XYToPolar := PolarPoint;
end;

Function TDart.PolarToXY(PolarPoint : TPolarPoint):TPoint;
Var
  Point : TPoint;
  V : real;
Begin
  V := PolarPoint.V/360*2*pi;
  Point.X := Round(PolarPoint.R*Sin(V));
  Point.Y := Round(PolarPoint.R*Cos(V));
  PolarToXY := Point;
end;

Procedure TDart.CalculateRadier;
Begin
  FMemWidth := Width;
  FMemHeight := Height;
  FCenter.X := (Width DIV 2);
  FCenter.Y := Height DIV 2;
  If Width > Height Then
    FDoubleMaxRadius := FCenter.Y
  else
    FDoubleMaxRadius := FCenter.X;
  FBullRadius := Round(FDoubleMaxRadius*FBullFactor/1000);
  FDoubleBullRadius := Round(FDoubleMaxRadius*FDoubleBullFactor/1000);
  FTribleMinRadius := Round(FDoubleMaxRadius*FTribleMinFactor/1000);
  FTribleMaxRadius := Round(FDoubleMaxRadius*FTribleMaxFactor/1000);
  FDoubleMinRadius := Round(FDoubleMaxRadius*FDoubleMinFactor/1000);
end;

Procedure TDart.CalculateDrawPoints;
Var
  Count : Integer;
  Point : TPoint;
  PolarPoint : TPolarPoint;
Begin
  For Count := 1 to 20 do
  Begin
    PolarPoint.R := FDoubleMaxRadius;
    PolarPoint.V := Count*18-9;
    Point := PolarToXY(PolarPoint);
    Point.X := Point.X + FCenter.X;
    Point.Y := Point.Y + FCenter.Y;
    FDrawPoints[1,Count] := Point;

    PolarPoint.R := FBullRadius;
    Point := PolarToXY(PolarPoint);
    Point.X := Point.X + FCenter.X;
    Point.Y := Point.Y + FCenter.Y;
    FDrawPoints[2,Count] := Point;
  end;

end;

Procedure TDart.Calculate;
Begin
  CalculateRadier;
  CalculateDrawPoints;
end;

Procedure TDart.Paint;
Var
  Point : TPoint;
  PolarPoint : TPolarPoint;
  TribleRadius, DoubleRadius : LongInt;
  Count : Integer;
Begin
{  Inherited Paint;}
  If (FMemWidth <> Width) OR (FMemHeight <> Height) Then
    Calculate;
  Canvas.Brush.Color := FBackColor;
  Canvas.Brush.Style := bsSolid;
  Canvas.Pen.Width := 0;
  With FCenter do
    Canvas.Ellipse(X - FDoubleMaxRadius, Y - FDoubleMaxRadius,
                   X + FDoubleMaxRadius, Y + FDoubleMaxRadius);
  Canvas.Pen.Color := FFrameColor;
  Canvas.Pen.Width := FFrameWidth;
  Canvas.Brush.Color := FFirstColor;
  With FCenter do
    Canvas.Ellipse(X - FBullRadius, Y - FBullRadius,
                   X + FBullRadius, Y + FBullRadius);
  Canvas.Brush.Color := FSecondColor;
  With FCenter do
    Canvas.Ellipse(X - FDoubleBullRadius, Y - FDoubleBullRadius,
                   X + FDoubleBullRadius, Y + FDoubleBullRadius);
  Canvas.Brush.Style := bsClear;
  With FCenter do
    Canvas.Ellipse(X - FTribleMinRadius, Y - FTribleMinRadius,
                   X + FTribleMinRadius, Y + FTribleMinRadius);
  With FCenter do
    Canvas.Ellipse(X - FTribleMaxRadius, Y - FTribleMaxRadius,
                   X + FTribleMaxRadius, Y + FTribleMaxRadius);
  With FCenter do
    Canvas.Ellipse(X - FDoubleMinRadius, Y - FDoubleMinRadius,
                   X + FDoubleMinRadius, Y + FDoubleMinRadius);

  TribleRadius := FTribleMinRadius +
                  ((FTribleMaxRadius - FTribleMinRadius) DIV 2);
  DoubleRadius := FDoubleMinRadius +
                  ((FDoubleMaxRadius - FDoubleMinRadius) DIV 2);

  Canvas.Brush.Style := bsSolid;
  For Count := 1 to 20 do
  Begin
    Canvas.MoveTo(FDrawPoints[1,Count].X,FDrawPoints[1,Count].Y);
    Canvas.LineTo(FDrawPoints[2,Count].X,FDrawPoints[2,Count].Y);
  end;
  Canvas.Brush.Style := bsSolid;
  For Count := 1 to 20 do
  Begin
    If (Count MOD 2)=0 then
      Canvas.Brush.Color := FSecondColor
    else
      Canvas.Brush.Color := FFirstColor;
    PolarPoint.R := DoubleRadius;
    PolarPoint.V := Count*18;
    Point := PolarToXY(PolarPoint);
    Point.X := Point.X + FCenter.X;
    Point.Y := Point.Y + FCenter.Y;
    Canvas.FloodFill(Point.X,Point.Y, FBackColor,fsSurface);

    PolarPoint.R := TribleRadius;
    Point := PolarToXY(PolarPoint);
    Point.X := Point.X + FCenter.X;
    Point.Y := Point.Y + FCenter.Y;
    Canvas.FloodFill(Point.X,Point.Y, FBackColor,fsSurface);
  end;
end;

Procedure TDart.MouseMove(Shift : TShiftState; X, Y : Integer);
Var
  Point : TPoint;
  PolarPoint : TPolarPoint;
  Points : Integer;
Begin
  Point.X := X-FCenter.X;
  Point.Y := FCenter.Y-Y;
  Points := 0;
  PolarPoint := XYToPolar(Point);
  If PolarPoint.R > FDoubleMaxRadius Then
  Begin
    SetPoints(Points);
    Exit;
  end;
  With PolarPoint do
  Begin
    If (V >= 0) and (V <= 9) Then
      Points := 6
    else
      If (V > 9) and (V <= 27) Then
        Points := 13
      else
        If (V > 27) and (V <= 45) Then
          Points := 4
        else
          If (V > 45) and (V <= 63) Then
            Points := 18
          else
            If (V > 63) and (V <= 81) Then
              Points := 1
            else
              If (V > 81) and (V <= 99) Then
                Points := 20
              else
                If (V > 99) and (V <= 117) Then
                  Points := 5
                else
                  If (V > 117) and (V <= 135) Then
                    Points := 12
                  else
                    If (V > 135) and (V <= 153) Then
                      Points := 9
                    else
                      If (V > 153) and (V <= 171) Then
                        Points := 14
                      else
                        If (V > 171) and (V <= 189) Then
                          Points := 11
                        else
                          If (V > 189) and (V <= 207) Then
                             Points := 8
                          else
                            If (V > 207) and (V <= 225) Then
                              Points := 16
                            else
                              If (V > 225) and (V <= 243) Then
                                Points := 7
                              else
                                If (V > 243) and (V <= 261) Then
                                  Points := 19
                                else
                                  If (V > 261) and (V <= 279) Then
                                    Points := 3
                                  else
                                    If (V > 279) and (V <= 297) Then
                                      Points := 17
                                    else
                                      If (V > 297) and (V <= 315) Then
                                        Points := 2
                                      else
                                        If (V > 315) and (V <= 333) Then
                                          Points := 15
                                        else
                                          If (V > 333) and (V <= 351) Then
                                            Points := 10
                                          else
                                            If (V > 351) and (V <= 360) Then
                                              Points := 6;
    If R < FDoubleBullRadius Then
      Points := 50
    else
      If R < FBullRadius Then
        Points := 25
      else
        If (R > FTribleMinRadius) AND (R < FTribleMaxRadius) Then
          Points := Points * 3
        else
          If (R > FDoubleMinRadius) AND (R < FDoubleMaxRadius) Then
            Points := Points * 2;
    SetPoints(Points);
  end;
  Inherited MouseMove(Shift,X,Y);
end;

Procedure TDart.SetBackColor(Color : TColor);
Begin
  If Color = FFrameColor Then Exit;
  If FBackColor = Color Then Exit;
  FBackColor := Color;
  Refresh;
end;

Procedure TDart.SetFirstColor(Color : TColor);
Begin
  If FFirstColor = Color Then Exit;
  FFirstColor := Color;
  Refresh;
end;

Procedure TDart.SetSecondColor(Color : TColor);
Begin
  IF FSecondColor = Color Then exit;
  FSecondColor := Color;
  Refresh;
end;

Procedure TDart.SetFrameColor(Color : TColor);
Begin
  IF Color = FBackColor Then Exit;
  If FFrameColor = Color Then Exit;
  FFrameColor := Color;
  Refresh;
end;

Procedure TDart.SetFrameWidth(W : Integer);
Begin
  If W <= 0 Then Exit;
  If FFrameWidth = W Then Exit;
  FFrameWidth := W;
  Refresh;
end;

Procedure TDart.SetShowNumbers(Show: Boolean);
Begin
  IF Show = FShowNumbers Then Exit;
  FShowNumbers := Show;
  Refresh;
end;

Procedure TDart.SetPoints(Points : Integer);
Begin
  If FPoints = Points Then Exit;
  FPoints := Points;
  PointsChanged(FPoints);
end;

Procedure TDart.PointsChanged(Points : Integer);
Begin
  If Assigned(FOnPointsChanged) Then
    FOnPointsChanged(Self, FPoints);
end;

end.
